import React, { useState, useEffect, useRef } from 'react';
import { Select } from 'antd';
import apis from '../../services/apis';
import request from '../../utils/request'

const { Option } = Select;

function usePrevious(props) {
  const ref = useRef();
  useEffect(() => {
    ref.current = props;
  });
  return ref.current;
}

/**
 *
 *
 * @param {*} props
 * @returns
 */
const RoomSelect = props => {
  const [data, setData] = useState([])
  const [value, setValue] = useState([])
  useEffect(() => {
    getList();
  }, [props.value])


  const getList = e => {
    request({ ...apis.house.room, params: { pageNum: 1, pageSize: 999, buildingId: props.buildingId, blockId: props.blockId, unitId: props.unitId, floorId: props.floorId} }).then(data => {
        setData(data.records)
        checkValue(data.records)
        // 默认选中第一个
    })
  }


  const checkValue = (data) => {
    if (props.value) {
      const tempData = data.filter(f => f.buildingId == props.value)
      const va = (tempData.length > 0) ? props.value : '已删除，请重新选择'
      props.onChange(va)

    }
  }

  return (
      <Select
      showSearch
      value={props.value}
      style={{ width: '300px' }}
      placeholder="请选择房号"
      onChange={props.onChange}
      filterOption={(input, option) =>
        option.props.children && option.props.children.toLowerCase().indexOf(input.toLowerCase()) >= 0
      }>
          {data.map(room => (
            <Option key={room.roomId} value={room.roomId}>{room.roomName}</Option>
          ))}
      </Select>
  )
}
export default RoomSelect
